# KvȃpbP[W[h
library(ggplot2)

# TvTCYƌJԂ񐔂̐ݒ
sample_size <- 30
num_samples <- 1000
bin_width <- 0.1  # qXgÕrݒ

# W{UƕsΕUi[xNg̏
sample_variances <- numeric(num_samples)
unbiased_variances <- numeric(num_samples)

# f[^ƕUvZ
set.seed(123)  # V[h̐ݒ
for (i in 1:num_samples) {
  sample <- rnorm(sample_size)  # WKz̃Tv
  sample_variances[i] <- var(sample) * (sample_size - 1) / sample_size  # W{U
  unbiased_variances[i] <- var(sample)  # sΕU
}

# U̕pxzf[^t[쐬
variances_df <- data.frame(
  Variance = c(sample_variances, unbiased_variances),
  Type = rep(c("Sample Variance", "Unbiased Variance"), each = num_samples)
)

# qXgOƃJC敪zPDFKiĕ`
ggplot(variances_df, aes(x = Variance, fill = Type)) +
  geom_histogram(aes(y = ..density..), position = "identity", alpha = 0.5, binwidth = bin_width) +
  stat_function(fun = function(x) dchisq(x * (sample_size - 1), df = sample_size - 1) * (sample_size - 1), 
                color = "black", size = 1) +
  labs(title = "Normalized Distribution of Sample and Unbiased Variances",
       x = "Variance",
       y = "Density") +
  scale_fill_manual(values = c("Sample Variance" = "blue", "Unbiased Variance" = "red")) +
  theme_minimal()
